﻿//////////////////////////////////////////////
// JpgFrame.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkImages
#include "JpgComponentType.h"

/// Class ------------------------------------

namespace nkImages
{
	struct JpgFrameComponentDescriptor final
	{
		JPG_COMPONENT_TYPE _type = JPG_COMPONENT_TYPE::COMPONENT_Y ;
		unsigned char _sampling = 0u ;
		unsigned char _quantizationTableIndex = 0u ;

		unsigned char _samplingFactorW = 0u ;
		unsigned char _samplingFactorH = 0u ;
	} ;

	class JpgFrame final
	{
		public :

			// Attributes
			// Dimension information
			unsigned short _width = 0u ;
			unsigned short _height = 0u ;

			// Pixel info
			unsigned char _bitsPerPixels = 0u ;
			unsigned char _componentCount = 0u ;

			// Component info
			JpgFrameComponentDescriptor _components [3] ;

		public :

			// Functions
			// Parsing
			static JpgFrame parseFromMarker (const unsigned char* data) ;
	} ;
}