﻿//////////////////////////////////////////////
// JpgHuffmanTable.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkMemory
#include <NilkinsMemory/Containers/BufferView.h>

// Standards
#include <vector>

/// Class ------------------------------------

namespace nkImages
{
	class JpgHuffmanTable final
	{
		public :

			// Attributes
			nkMemory::BufferView<const unsigned char> _table ;
			unsigned char _perBitsCounts [16] = {0u} ;
			unsigned char _smallestSymbolBits = 0 ;
			unsigned char _biggestSymbolBits = 0 ;

		public :

			// Functions
			// Parsing
			static void parseFromMarker (const unsigned char* data, std::vector<JpgHuffmanTable>& output) ;
	} ;
}