﻿//////////////////////////////////////////////
// MainSystem.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkInputs
{
	class InputSystem ;
}

/// Includes ---------------------------------

// nkInputs
#include "../Dll/DllDefines.h"

// Common
#include <nilkinsCommon/Patterns/SingletonClass.h>

/// Class ------------------------------------

namespace nkInputs
{
	class DLL_INPUTS_EXPORT MainSystem final : public nkCommon::SingletonClass<MainSystem>
	{
		friend class nkCommon::SingletonClass<MainSystem> ;

		private :

			// Attributes
			// Internal created input system
			InputSystem* _inputSystem ;

		private :

			// Functions
			// Constructor, destructor
			MainSystem () ;
			~MainSystem () ;
		
		public :			

			// Getters
			InputSystem* getInputSystem () const ;
			bool isInitialized () const ;

			// Init
			bool initialize () ;

			// Ending
			void shutdown () ;
	} ;
}